/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AboutActivity.java,v 3e7ea5dbefcb 2010/05/17 15:10:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.about;

import javax.annotation.Nonnull;
import org.openide.util.NbBundle;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import it.tidalwave.bluebill.mobile.android.R;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class AboutActivity extends Activity
  {
    public static final int AUTOMATIC_DISMISS_TIME = 10000;
    
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public void onCreate (final @Nonnull Bundle savedInstanceState)
      {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.about_activity);
        setTitle(NbBundle.getMessage(AboutActivity.class, "title"));

        findViewById(R.id.all).setOnClickListener(new View.OnClickListener()
          {
            public void onClick (final @Nonnull View view)
              {
                finish();
              }
          });

        new Handler().postDelayed(new Runnable()
          {
            @Override
            public void run()
              {
                finish();
              }
          }, AUTOMATIC_DISMISS_TIME);
      }
  }
