/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AddObservationControlFlow.java,v 3e7ea5dbefcb 2010/05/17 15:10:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.observation;

import javax.annotation.Nonnull;
import java.util.Arrays;
import it.tidalwave.mobile.android.ControlFlow;
import it.tidalwave.bluebill.mobile.android.location.PickLocationActivity;
import it.tidalwave.bluebill.mobile.android.taxonomy.browser.PickTaxonActivity;
import it.tidalwave.bluebill.mobile.android.taxonomy.browser.SpeciesBrowserActivity;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class AddObservationControlFlow extends ControlFlow
  {
    private final Condition addMore = new Condition()
      {
        public boolean compute (final @Nonnull Object... args)
          {
            return Arrays.asList(args).contains(CountAndGenderActivity.ADD_MORE);
          }
      };
    
    public AddObservationControlFlow()
      {
        startFrom(PickTaxonActivity.class);
        when(PickTaxonActivity.class).completes().thenForwardTo(CountAndGenderActivity.class);
        when(SpeciesBrowserActivity.class).completes().thenForwardTo(CountAndGenderActivity.class);
        when(CountAndGenderActivity.class).completesWith(addMore).thenForwardTo(PickTaxonActivity.class);
        when(CountAndGenderActivity.class).completesWithout(addMore).thenForwardTo(PickLocationActivity.class);
      }
  }
