/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: GenderHandler.java,v 3e7ea5dbefcb 2010/05/17 15:10:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.observation;

import javax.annotation.Nonnull;
import android.app.Activity;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.RadioButton;
import it.tidalwave.bluebill.mobile.observation.BirdGender;
import it.tidalwave.bluebill.mobile.android.R;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class GenderHandler
  {
    @Nonnull
    private final RadioButton rbGenderUnknown;

    @Nonnull
    private final RadioButton rbGenderMale;

    @Nonnull
    private final RadioButton rbGenderFemale;

    @Nonnull
    private final RadioButton rbGenderImmature;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    private final OnCheckedChangeListener inputEnabler = new OnCheckedChangeListener()
      {
        public void onCheckedChanged (final @Nonnull CompoundButton button, final boolean checked)
          {
            if (checked) // FIXME: use a Group for this!
              {
                rbGenderUnknown.setChecked(button == rbGenderUnknown);
                rbGenderMale.setChecked(button == rbGenderMale);
                rbGenderFemale.setChecked(button == rbGenderFemale);
                rbGenderImmature.setChecked(button == rbGenderImmature);
              }
          }
      };

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public GenderHandler (final @Nonnull Activity activity)
      {
        rbGenderUnknown = (RadioButton)activity.findViewById(R.id.rbGenderUnknown);
        rbGenderMale = (RadioButton)activity.findViewById(R.id.rbGenderMale);
        rbGenderFemale = (RadioButton)activity.findViewById(R.id.rbGenderFemale);
        rbGenderImmature = (RadioButton)activity.findViewById(R.id.rbGenderImmature);

        rbGenderUnknown.setOnCheckedChangeListener(inputEnabler);
        rbGenderMale.setOnCheckedChangeListener(inputEnabler);
        rbGenderFemale.setOnCheckedChangeListener(inputEnabler);
        rbGenderImmature.setOnCheckedChangeListener(inputEnabler);

        rbGenderUnknown.setChecked(true);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public BirdGender getGender()
      {
        if (rbGenderUnknown.isChecked())
          {
            return BirdGender.UNKNOWN;
          }
        if (rbGenderMale.isChecked())
          {
            return BirdGender.MALE;
          }
        if (rbGenderFemale.isChecked())
          {
            return BirdGender.FEMALE;
          }
        if (rbGenderImmature.isChecked())
          {
            return BirdGender.IMMATURE;
          }

        return BirdGender.UNKNOWN; // defensive
      }
  }
